#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc,char *argv[]){
  int rank,size;
  MPI_Init(&argc,&argv);       
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  
  if (rank>0) {
    srand(123+rank);     // Safe because each job has a fully private memory space
    int random = rand();
    fprintf(stderr,"node %d generated number %d\n",rank,random);
    MPI_Send(&random,1,MPI_INT,0,0,MPI_COMM_WORLD); // Send to rank=0
  } else {
    int count = 1, tmp;
    while (count<size) {
      MPI_Recv(&tmp,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,NULL); // Receive
      fprintf(stderr,"Node 0 received number %d\n",tmp);
      count++;
    }}
  
  MPI_Finalize();
  return 0;
}
