#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc,char *argv[]){
  int rank, size;
  MPI_Status mpi_status;

  MPI_Init(&argc,&argv);   
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);

  if (rank>0) {
    srand(123+rank);
    int random = rand();
    fprintf(stderr,"node %d generated number %d\n",rank,random);
    MPI_Send(&random,1,MPI_INT,0,0,MPI_COMM_WORLD);
  } else {
    int count = 1, tmp, sender;
    while (count<size) {
      MPI_Recv(&tmp,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,&mpi_status);
      sender = mpi_status.MPI_SOURCE;     // Use status variable to discover who is the sender
      fprintf(stderr,"Node 0 received number %d from node %d\n",tmp,sender);
      count++;
    }}
  
  MPI_Finalize();
  return 0;
}
