#include <stdio.h>
#include <mpi.h>

int main(int argc,char *argv[]){
  int rank, size, tmp;
  MPI_Status mpi_status;

  MPI_Init(&argc,&argv);               
  MPI_Comm_size(MPI_COMM_WORLD,&size); 
  MPI_Comm_rank(MPI_COMM_WORLD,&rank); 

  if (rank>0) { // Nodes>0: post a (blocking) Receive
    MPI_Recv(&tmp,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,&mpi_status);
    fprintf(stderr,"node %d received token %d from node %d\n",rank,tmp,mpi_status.MPI_SOURCE);
  }

  if (rank==0) tmp=-1; // Everybody: Send "tmp" to next node
  MPI_Send(&tmp,1,MPI_INT,(rank+1)%size,0,MPI_COMM_WORLD);

  if (rank==0) { // Node 0: final Reveive 
    MPI_Recv(&tmp,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,&mpi_status);
    fprintf(stderr,"node %d received token %d from node %d\n",rank,tmp,mpi_status.MPI_SOURCE);
  }
  
  MPI_Finalize();
  return 0;
}
