#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <mpi.h>
 
int main(int argc,char** argv){
  int          rank, size,i,buffsize=1000000;
  MPI_Status   status;
  MPI_Request  send_request,recv_request;
  double       *sendbuff,*recvbuff;

  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
 
  buffsize=atoi(argv[1]);
  sendbuff=(double *)malloc(sizeof(double)*buffsize);
  recvbuff=(double *)malloc(sizeof(double)*buffsize);
  srand(1234 + rank);
  for(i=0;i<buffsize;i++) sendbuff[i]=(double)rand()/RAND_MAX;
  
  MPI_Isend(sendbuff,buffsize,MPI_DOUBLE,(rank+1)%size,0,MPI_COMM_WORLD,&send_request);   
  MPI_Irecv(recvbuff,buffsize,MPI_DOUBLE,(rank-1+size)%size,0,MPI_COMM_WORLD,&recv_request);

  // here, sendbuff and recvbuff cannot be used, but one may perform
  // any computations that do not touch them
  
  MPI_Wait(&send_request,&status);
  MPI_Wait(&recv_request,&status);
 
  MPI_Finalize();
}
