#include <stdio.h>
#include <mpi.h>

int main (int argc, char *argv[]){
  int size, rank, next, prev, buf[2], tag1=1, tag2=2;
  MPI_Request requests[4];
  MPI_Status status[4];
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
  prev = (rank-1+size)%size;
  next = (rank+1)%size;
  // Initiate a bunch of communications (they all return immediately)
  MPI_Irecv(&buf[0], 1, MPI_INT, prev, tag1, MPI_COMM_WORLD, &requests[0]);
  MPI_Irecv(&buf[1], 1, MPI_INT, next, tag2, MPI_COMM_WORLD, &requests[1]);
  MPI_Isend(&rank,   1, MPI_INT, prev, tag2, MPI_COMM_WORLD, &requests[2]);
  MPI_Isend(&rank,   1, MPI_INT, next, tag1, MPI_COMM_WORLD, &requests[3]);
  //
  // do something else, then wait for completion of all communications
  //
  MPI_Waitall(4, requests, status);
  printf("Task %d communicated with tasks %d & %d\n",rank,prev,next);
  
  MPI_Finalize();
}
