#include <stdio.h>
#include <mpi.h>

int main(int argc,char *argv[]){
  int rank, size, tmp, final;
  MPI_Status status;
  MPI_Request request;

  MPI_Init(&argc,&argv);         
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);

  // Node 0 posts an early non-blocking receive, others post a blocking one
  if (rank==0) {MPI_Irecv(&final,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,&request);tmp = -1;}
  else {MPI_Recv(&tmp,1,MPI_INT,MPI_ANY_SOURCE,0,MPI_COMM_WORLD,&status);}

  // Everybody: pass value to the next node
  MPI_Send(&tmp,1,MPI_INT,(rank+1)%size,0,MPI_COMM_WORLD);
  
  if (rank==0) MPI_Wait(&request,&status); // Node 0 must check that Receive has completed
  fprintf(stderr,"node %d received token %d from node %d\n",rank,tmp,status.MPI_SOURCE);

  MPI_Finalize();
  return 0;
}
