
// F. Gelis -- Last modified on 2019/06/17


#define NT 16        // number of openMP threads

#define NP 1023      // number of values of p,omega
#define MP   60     
#define MPsi 24      // should be a multiple of 4 


typedef struct {
  double *f;
  double *p;
  double *om;
  double *eps;
  double *logeps;
  double *f0;
  double *p0;
  double *om0;
  double *eps0;
  double *logeps0;
  double pmin;
  double pmax;
  double fact;
  double logfact;
  double invlogfact;
  double omMax;
  double epsMax;
  double logepsMax;
  double omMin;
  double epsMin;
  double logepsMin;
  double dom;
  double invdom;
  double dlogeps;
  double invdlogeps;
  ////////////////
  double n0;
  int N;
  double mass;
  double mass2;
  double lambda;
} dist_t;


typedef enum { QUANTUM, CLASSICAL, CLASSICAL0, INTERPOL} quant_t;


#define max(x,y) (0.5*((x)+(y)+fabs((x)-(y))))


dist_t *F_init_om(int N,double mass,double pmax,double(*f)(double),double lambda);

double feq_full(double p);
double feq_class(double p);
double f1(double p);
double f2(double p);
double f3(double p);
double f4(double p);
double naoto(double p);
double cgc(double p);

double E_F(dist_t *F);
double N_F(dist_t *F);
double S_F(dist_t *F);
double Sc_F(dist_t *F);

int increment_F_Euler(double dt,double g,dist_t *F,quant_t approx);
void init_w(dist_t *F);

double MatEl2_f(double p1,double p2,double p3,double p4,double om1,double om2,double om3,double om4,double pmin,dist_t *F);


double MatEl2_(double d12,double d34,double s12,double s34,\
	       double om1,double om2,double om3,double om4,\
	       double P,dist_t *F);
